local mod = RW:Boss("Deathbringer Saurfang", "Icecrown Citadel", "Icecrown Citadel", "The Entryway")
local L

-- 3.3?
if not QueryQuestsCompleted then return end

---------------------------
-- Variables
local tAddsCD, wAdds
local mMark, wMarkSoon
local wFrenzy
local mRune, tRuneDur

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Deathbringer Saurfang"
		
		L.blood_opt = "Blood Power \"health\" frame"
		L.blood = "Blood Power"
		
		L.mark_frame = "Mark Count"
		L.mark_frame_opt = "Counter for nr of Marks"
		
		L.mark_soon = GetSpellInfo(72293) .." soon"
		L.mark_soon_opt = "Warning at 90 stacks"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(37813)
	self:SetWin()
	
	self:AddBoolOption("BloodPFrame", L.blood_opt, nil, nil, select(3, GetSpellInfo(72370)))
	self:AddBoolOption("MarkFrame", L.mark_frame_opt, nil, nil, select(3, GetSpellInfo(72254)))
	
	tAddsCD		= self:CDTimer(30, 72173)
	tRuneDur	= self:DurTargetTimer(30 ,72410)
	
	wAdds		= self:Warning(72173)
	wMarkSoon	= self:CustomWarning({L.mark_soon, L.mark_soon_opt}, 72293)
	wFrenzy		= self:Warning(72737)
	
	mMark		= self:TargetMessage(72293)
	mRune		= self:TargetMessage(72410)
end

---------------------------
-- Locals
local bloodStacks
local markSpamm
local markCount
local summonSpamm

local function updateBlood()	
	local uID = mod:UIDFromCID(37813)
	if uID then
		bloodStacks = UnitPower(uID) / UnitPowerMax(uID)
	end
	if bloodStacks > 0.90 then
		if (GetTime() - markSpamm) > 4 then
			wMarkSoon:Show()
			markSpamm = GetTime()
		end
	end
	return bloodStacks
end

local function updateMarks()
	return markCount, 15
end

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Adds", 72173, 72357, 72356, 72358, 72172)
	self:Track("Mark", 72254, 72280, 72293, 72444, 72445, 72279, 72260, 72278, 72255, 72256, 72446)
	self:Track("Frenzy", 72737)
	self:Track("Rune", 72410, 72408, 72409, 72447, 72448, 72449)
	
	markSpamm = 0
	summonSpamm = 0
	markCount = 0
	
	if self.db.profile.BloodPFrame then
		self:SendMessage("RW_AddHealthFrame", updateBlood, L.blood, select(3, GetSpellInfo(72370)))
	end
	if self.db.profile.MarkFrame then
		self:SendMessage("RW_AddHealthFrame", updateMarks, L.mark_frame, select(3, GetSpellInfo(72254)), "STACK")
	end
	
	tAddsCD:Start()
	tFrenzyCD:Start()
end

function mod:Adds(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		if (GetTime() - summonSpamm) > 2 then
			tAddsCD:Start()
			wAdds:Show()
			summonSpamm = GetTime()
		end
	end
end

function mod:Mark(event, args)
	if event == "SPELL_AURA_APPLIED" then
		mMark:Show(args.dName)
		markCount = markCount + 1
	end
end

function mod:Frenzy(event, args)
	if event == "SPELL_AURA_APPLIED" then
		wFrenzy:Show()
	end
end

function mod:Rune(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tRuneDur:Start(args.dName)
		mRune:Show(args.dName)
	end
end